----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:20:32 10/16/2008 
-- Design Name: 
-- Module Name:    EB_top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,MYLIB;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use mylib.dcc_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity EB_top is
		generic (sim : boolean := false);
    Port ( TXCLK_p : in  STD_LOGIC;
					 TXCLK_n : in  STD_LOGIC;
           TXD_p : in  STD_LOGIC_VECTOR (4 downto 0);
           TXD_n : in  STD_LOGIC_VECTOR (4 downto 0);
           RXCLK_P : out  STD_LOGIC;
           RXCLK_n : out  STD_LOGIC;
           RXD_P : out  STD_LOGIC_VECTOR (4 downto 0);
           RXD_n : out  STD_LOGIC_VECTOR (4 downto 0);
           INIT_B : out  STD_LOGIC;
-- LRB interafce
           LRB_TCLK_p : in  STD_LOGIC_VECTOR (4 downto 0);
           LRB_TCLK_n : in  STD_LOGIC_VECTOR (4 downto 0);
           LRB_CLK_P : out  STD_LOGIC_VECTOR (4 downto 0);
           LRB_CLK_n : out  STD_LOGIC_VECTOR (4 downto 0);
           LRB_RD_P : out  STD_LOGIC_VECTOR (4 downto 0);
           LRB_RD_n : out  STD_LOGIC_VECTOR (4 downto 0);
					 LRB_TD_p : in td_array;
					 LRB_TD_n : in td_array;
---- TTS output
           OUT_OF_SYNC : out  STD_LOGIC;
           OVERFLOW : out  STD_LOGIC;
           BUSY : out  STD_LOGIC;
           READY : out  STD_LOGIC;
---- ethernet interface
           E_CSn : out  STD_LOGIC;
           E_WRn : out  STD_LOGIC;
           E_RDn : out  STD_LOGIC;
           E_ADDR : out  STD_LOGIC_VECTOR (1 downto 0);
           E_DATA : inout  STD_LOGIC_VECTOR (7 downto 0);
           E_RESETn : out  STD_LOGIC;
           E_INTn : in  STD_LOGIC;
-- TTCrx interface
           T_clock40des : in  STD_LOGIC;
           T_ttcready : in  STD_LOGIC;
           T_l1accept : in  STD_LOGIC;
           T_brcststr : in  STD_LOGIC;
           T_brcst : in  STD_LOGIC_VECTOR (7 downto 2);
           T_sinerrstr : in  STD_LOGIC;
           T_dberrstr : in  STD_LOGIC;
           T_evcntres : in  STD_LOGIC;
           T_bcntres : in  STD_LOGIC;
           T_bcntstr : in  STD_LOGIC;
           T_reset_b : out  STD_LOGIC;
           T_scl : out  STD_LOGIC;
           T_sda : inout  STD_LOGIC;
           T_id : out  STD_LOGIC_VECTOR (13 downto 0);
-- SLINK interface
           LDOWNn : in  STD_LOGIC;
           LFFn : in  STD_LOGIC;
           LRL : in  STD_LOGIC_VECTOR (3 downto 0);
           LSF : in  STD_LOGIC_VECTOR (3 downto 0);
           UCLK : out  STD_LOGIC;
           UTESTn : out  STD_LOGIC;
           UWENn : out  STD_LOGIC;
           URESETn : out  STD_LOGIC;
           UCTRLn : out  STD_LOGIC;
           UDW : out  STD_LOGIC_VECTOR (1 downto 0);
           UD : out  STD_LOGIC_VECTOR (63 downto 0);
           USF : out  STD_LOGIC_VECTOR (3 downto 0);
---- backplane connection
           SL_RX_CLK_p : in  STD_LOGIC;
           SL_RX_CLK_n : in  STD_LOGIC;
           SL_RXD_p : in  STD_LOGIC_VECTOR (4 downto 0);
           SL_RXD_n : in  STD_LOGIC_VECTOR (4 downto 0);
           SL_TX_CLK_p : out  STD_LOGIC;
           SL_TX_CLK_n : out  STD_LOGIC;
           SL_TXD_p : out  STD_LOGIC_VECTOR (4 downto 0);
           SL_TXD_n : out  STD_LOGIC_VECTOR (4 downto 0);
           CCLK : in  STD_LOGIC;
-- SDRAM ports
					 mclkio : inout STD_LOGIC;
					 mdq : inout STD_LOGIC_VECTOR (15 downto 0);
					 ma : out STD_LOGIC_VECTOR (12 downto 0);
					 mba : out STD_LOGIC_VECTOR (1 downto 0);
					 dm : out STD_LOGIC_VECTOR (1 downto 0);
					 dqs : inout STD_LOGIC_VECTOR (1 downto 0);
					 we_n : out STD_LOGIC;
					 ras_n : out STD_LOGIC;
					 cas_n : out STD_LOGIC;
					 cs_n : out STD_LOGIC;
					 mclke : out STD_LOGIC;
					 mclk : out STD_LOGIC;
					 mclk_n : out STD_LOGIC
					 );
end EB_top;

architecture Behavioral of EB_top is
signal state: std_logic_vector(3 downto 0) := (others => '0');
signal reset: std_logic := '0';
signal reset_err: std_logic := '0';
signal rst_ddr_pa: std_logic := '0';
signal n_strobe: std_logic := '0';
signal strobe: std_logic := '0';
signal run: std_logic := '0';
signal mem_test: std_logic := '0';
signal we_byte: std_logic_vector(3 downto 0) := (others => '0');
signal w_data: std_logic_vector(31 downto 0) := (others => '0');
signal addr: std_logic_vector(15 downto 0) := (others => '0');
signal test_ctrl: std_logic_vector(31 downto 0) := (others => '0');
signal status: std_logic_vector(31 downto 0) := (others => '0');
signal LRB_Tclk_in: std_logic_vector(4 downto 0) := (others => '0');
signal LRB_Tclk: std_logic_vector(4 downto 0) := (others => '0');
--signal SL_RX_clk_in: std_logic := '0';
--signal SL_RX_clk_dcm: std_logic := '0';
--signal SL_RX_clkn_dcm: std_logic := '0';
--signal SL_RX_clk: std_logic := '0';
--signal SL_RX_clkn: std_logic := '0';
--signal SL_RX_clk_locked: std_logic := '0';
--signal SL_TXCLK: std_logic := '0';
--signal SL_TXD: std_logic_vector(4 downto 0) := (others => '0');
--signal SL_RXD: std_logic_vector(4 downto 0) := (others => '0');
--signal SL_tx_data: std_logic_vector(9 downto 0) := (others => '0');
--signal SL_rx_data: std_logic_vector(9 downto 0) := (others => '0');
signal ttc_clk: std_logic := '0';
signal clk: std_logic := '0';
signal clk180: std_logic := '0';
signal clk_dcm: std_logic := '0';
signal clk180_dcm: std_logic := '0';
signal resync_done : std_logic := '0';
signal ttc_resync : std_logic := '0';
signal dcc_quiet : std_logic := '0';
signal oc_cntr : std_logic_vector(3 downto 0) := (others => '0');
signal ddr_pa_off : std_logic_vector(9 downto 0) := (others => '0');
--signal tc : std_logic := '0';
signal rst_VMEp: std_logic := '0';
signal rst_VME: std_logic := '0';
signal VMEclk_in: std_logic := '0';
signal mclk0_dcm: std_logic := '0';
signal mclk90_dcm: std_logic := '0';
signal clkfx: std_logic := '0';
signal vmeclk: std_logic := '0';
signal clkfx_dcm: std_logic := '0';
signal vmeclk_dcm: std_logic := '0';
signal mclk0: std_logic := '0';
signal mclk90: std_logic := '0';
signal mclk180: std_logic := '0';
signal mclk270: std_logic := '0';
signal locked: std_logic_vector(1 downto 0) := (others => '0');
signal locked_dl: std_logic_vector(1 downto 0) := (others => '0');
signal rst_clk: std_logic := '0';
signal rst_mclk: std_logic := '0';
-- TTCrx signals
signal rst_ttc: std_logic := '0';
signal ttc_cal_win: std_logic_vector(31 downto 0) := (others => '0');
signal ttc_id: std_logic_vector(31 downto 0) := (others => '0');
signal ttc_i2c_data: std_logic_vector(31 downto 0) := (others => '0');
signal ttc_bcn_offset: std_logic_vector(31 downto 0) := (others => '0');
signal event_number_avl: std_logic := '0';
signal event_number: std_logic_vector(59 downto 0) := (others => '0');
signal en_brcst: std_logic := '0';
signal ttc_start: std_logic := '0';
signal ttc_stop: std_logic := '0';
signal ttc_evcnt_reset: std_logic := '0';
signal ttc_soft_reset: std_logic := '0';
signal ttc_soft_resetp: std_logic := '0';
signal ttc_ready: std_logic := '0';
signal ttc_serr: std_logic := '0';
signal ttc_derr: std_logic := '0';
signal inc_oc: std_logic := '0';
signal inc_l1ac: std_logic := '0';
signal inc_bcnterr: std_logic := '0';
signal inc_serr: std_logic := '0';
signal inc_derr: std_logic := '0';
signal inc_rate_OFW: std_logic := '0';
signal ttc_bcnt_err: std_logic := '0';
signal rate_OFW: std_logic := '0';
signal rate_OFWp: std_logic := '0';
signal rate_OFW_q: std_logic := '0';
signal sync_lost: std_logic := '0';
signal ovfl_warning: std_logic := '0';
signal evn_fifo_full: std_logic := '0';
signal timeout_data: std_logic_vector(31 downto 0) := (others => '0');
signal src_id_data: std_logic_vector(31 downto 0) := (others => '0');
-- slink SIGNALS
signal inc_slink_wc: std_logic := '0';
signal inc_slink_bc: std_logic := '0';
signal inc_crc_err: std_logic := '0';
signal slink64: std_logic := '0';
signal slink_ctrl: std_logic := '0'; -- marks BOE and EOE
signal slink_down: std_logic := '0';
signal slink_full: std_logic := '0';
signal en_slink: std_logic := '0';
signal slink_rst: std_logic := '0';
signal slink_send: std_logic := '0';
signal slink_test: std_logic := '0';
signal slink_we: std_logic := '0';
signal slink_pntr: std_logic_vector(31 downto 0) := (others => '0');
signal slink_data: std_logic_vector(35 downto 0) := (others => '0');
signal slink_buf: std_logic_vector(31 downto 0) := (others => '0');
-- sdram signals
signal rst_mem_data: std_logic := '0';
signal rfifo_dav: std_logic := '0';
signal ddr_gnt: std_logic := '0';
signal ddr_w_we: std_logic := '0';
signal ddr_read: std_logic := '0';
signal ddr_rqst: std_logic := '0';
signal mem_status: std_logic_vector(15 downto 0) := (others => '0');
signal mem_data: std_logic_vector(31 downto 0) := (others => '0');
signal ddr_length: std_logic_vector(5 downto 0) := (others => '0');
signal ddr_addr: std_logic_vector(22 downto 0) := (others => '0');
signal ddr_w_data: std_logic_vector(35 downto 0) := (others => '0');
signal vme_cycle: std_logic := '0';
signal LRB_ack: std_logic_vector(4 downto 0) := (others => '0');
signal test_ack: std_logic_vector(4 downto 0) := (others => '0');
signal addr_str: std_logic := '0';
signal vme_read: std_logic := '0';
signal SN: std_logic_vector(7 downto 0) := (others => '0');
signal got_SN: std_logic := '0';
signal rd_length: std_logic_vector(3 downto 0) := (others => '0');
signal wc: std_logic_vector(4 downto 0) := (others => '0');
signal wc4_dl: std_logic := '0';
-- monitor signals
signal mon_buf_empty: std_logic := '0';
signal mon_buf_full: std_logic := '0';
signal mon_buf_afull: std_logic := '0';
signal mon_fifo_afull: std_logic := '0';
signal mon_re: std_logic := '0';
signal mon_avl: std_logic := '0';
signal mon_we: std_logic := '0';
signal inc_ddr_pa: std_logic := '0';
signal inc_mon_cntr: std_logic := '0';
signal catch_offset: std_logic := '0';
signal ddr_pa: std_logic_vector(9 downto 0) := (others => '0');
signal mon_wp: std_logic_vector(6 downto 0) := (others => '0');
signal mon_data: std_logic_vector(33 downto 0) := (others => '0');
signal mon_ctrl: std_logic_vector(31 downto 0) := (others => '0');
signal mon_evt_wc: std_logic_vector(31 downto 0) := (others => '0');
signal inc_addr: std_logic := '0';
signal r_data_val: std_logic := '0';
signal r_data: std_logic_vector(31 downto 0) := (others => '0');
signal reg_data: std_logic_vector(31 downto 0) := (others => '0');
signal conf: std_logic_vector(31 downto 0) := (others => '0');
type init_value is array(9 downto 0) of bit_vector(15 downto 0);
-- LRB_link signals
signal update_led: std_logic := '0';
signal led_test: std_logic := '0';
constant lrb_id: std_logic_vector(14 downto 0) := "100011010001000";
signal lrb_en: std_logic_vector(14 downto 0) := (others => '0');
signal led: std_logic_vector(24 downto 0) := (others => '0');
signal led_in: std_logic_vector(24 downto 0) := (others => '0');
signal err_in: std_logic_vector(24 downto 0) := (others => '0');
signal event_data_str: std_logic_vector(4 downto 0) := (others => '0');
signal event_data_req: std_logic_vector(18 downto 0) := (others => '0');
signal re_event_info: std_logic_vector(4 downto 0) := (others => '0');
signal re_event_data: std_logic_vector(4 downto 0) := (others => '0');
signal rd_next_event: std_logic_vector(4 downto 0) := (others => '0');
signal LRB_data_dav: std_logic_vector(4 downto 0) := (others => '0');
signal event_info_rdy: std_logic_vector(4 downto 0) := (others => '0');
signal event_info_val: std_logic_vector(4 downto 0) := (others => '0');
signal event_data_rdy: std_logic_vector(4 downto 0) := (others => '0');
type v32_array is array(7 downto 0) of std_logic_vector(31 downto 0);
type v33_array is array(4 downto 0) of std_logic_vector(32 downto 0);
signal debug : v32_array;
signal LRB_data : v32_array;
signal event_data : v33_array;
signal event_info : v33_array;
type pol_array is array(4 downto 0) of std_logic_vector(11 downto 0);
constant polarity : pol_array := (x"f06",x"dc6",x"1fe",x"f19",x"d3c");
-- edc signals
signal lrb_test: std_logic := '0';
signal lrb_test_str: std_logic := '0';
signal lrb_test_data: std_logic_vector(31 downto 0) := (others => '0');
signal htr_buf_req: std_logic := '0';
signal htr_buf_ovf: std_logic_vector(14 downto 0) := (others => '0');
signal htr_buf_addr: std_logic_vector(11 downto 0) := (others => '0');
signal htr_buf_length: std_logic_vector(8 downto 0) := (others => '0');
signal event_buf_afull: std_logic := '0';
signal edc_status: std_logic_vector(31 downto 0) := (others => '0');
signal edc_counters: std_logic_vector(31 downto 0) := (others => '0');
signal mm_LUT_data: std_logic_vector(31 downto 0) := (others => '0');
signal HTR_state_LUT: std_logic_vector(31 downto 0) := (others => '0');
signal HTR_bz: std_logic := '0';
signal HTR_ow: std_logic := '0';
-- event builder signal
signal en_htr_ow: std_logic := '0';
signal en_htr_bz: std_logic := '0';
signal err_state: std_logic_vector(1 downto 0) := (others => '0');
signal status_cntr: std_logic_vector(31 downto 0) := (others => '0');
signal evn_mm_cntr: std_logic_vector(31 downto 0) := (others => '0');
signal evn_data: std_logic_vector(31 downto 0) := (others => '0');
signal evn_pntr: std_logic_vector(31 downto 0) := (others => '0');
signal eb_counters: std_logic_vector(31 downto 0) := (others => '0');
signal htr_status: std_logic_vector(14 downto 0) := (others => '0');
signal htr_error: std_logic_vector(14 downto 0) := (others => '0');
signal htr_state: std_logic_vector(1 downto 0) := (others => '0');
signal wp_addr: std_logic_vector(3 downto 0) := (others => '0');
signal rp_addr: std_logic_vector(3 downto 0) := (others => '0');
signal dpo_wp: std_logic_vector(8 downto 0) := (others => '0');
signal dpo_rp: std_logic_vector(8 downto 0) := (others => '0');
signal summary: std_logic_vector(31 downto 0) := (others => '0');
signal lrb_evn: std_logic_vector(40 downto 0) := (others => '0');
signal smry_ra: std_logic_vector(11 downto 0) := (others => '0');
signal evn_ra: std_logic_vector(11 downto 0) := (others => '0');
signal htr_rd_cnt: std_logic_vector(3 downto 0) := (others => '0');
signal htr_rd_cnt_str: std_logic := '0';
signal htr_buf_data: std_logic_vector(32 downto 0) := (others => '0');
signal htr_buf_val: std_logic := '0';
signal ethernet_data: std_logic_vector(31 downto 0) := (others => '0');
signal ethernet_dav: std_logic := '0';
signal e_data_out: std_logic_vector(7 downto 0) := (others => '0');
--signal e_wrn_i : STD_LOGIC := '0';
signal et_str : STD_LOGIC := '0';
signal et_read : STD_LOGIC := '0';
signal et_rd_length : STD_LOGIC_VECTOR (3 downto 0) := (others => '0');
signal et_addr : STD_LOGIC_VECTOR (15 downto 0) := (others => '0');
signal et_wdata : STD_LOGIC_VECTOR (31 downto 0) := (others => '0');
signal et_sel : STD_LOGIC := '0';
signal et_abort : STD_LOGIC := '0';
signal lfsr: std_logic_vector(31 downto 0) := (others => '0');
signal lfsr_reg: std_logic_vector(31 downto 0) := (others => '0');
signal mem_reg: std_logic_vector(31 downto 0) := (others => '0');
signal lfsr_err: std_logic := '0';
signal lfsr2: std_logic_vector(31 downto 0) := (others => '0');
signal lfsr2_reg: std_logic_vector(31 downto 0) := (others => '0');
signal w_data_reg: std_logic_vector(31 downto 0) := (others => '0');
signal ddr_w_addr: std_logic_vector(31 downto 0) := (others => '0');
signal lfsr2_err: std_logic := '0';
signal ctrl_length_err: std_logic_vector(31 downto 0) := (others => '0');
signal odd_ctrl: std_logic := '0';
signal odd_data: std_logic := '0';
signal data_length_err: std_logic_vector(31 downto 0) := (others => '0');
signal wr_evn: std_logic := '0';
signal last_evn: std_logic_vector(31 downto 0) := (others => '0');
signal last_w_addr: std_logic_vector(31 downto 0) := (others => '0');
attribute LOC : string;
attribute LOC of i_DCM_VMEclk : label is "DCM_x0y1"; -- left bottom
--attribute LOC of i_DCM_clk : label is "DCM_x1y3"; -- top right
attribute LOC of i_DCM_mclk : label is "DCM_x1y0"; -- bottom left
--attribute LOC of i_DCM_SL_RX_clk : label is "DCM_x3y2"; -- right top
attribute LOC of i_clkfx : label is "BUFGMUX_x0y6"; -- left E
attribute LOC of i_vmeclk : label is "BUFGMUX_x0y8"; -- left G
--attribute LOC of i_mclk90 : label is "BUFGMUX_x0y6"; -- left E
--attribute LOC of i_mclk270 : label is "BUFGMUX_x0y8"; -- left G
--attribute LOC of i_clkfx : label is "BUFGMUX_x0y8"; -- left G
attribute LOC of i_LRB0Tclk : label is "BUFGMUX_x2y1"; -- bottom A
attribute LOC of i_LRB1Tclk : label is "BUFGMUX_x3y3"; -- right B
attribute LOC of i_LRB2Tclk : label is "BUFGMUX_x1y1"; -- bottom C
attribute LOC of i_LRB3Tclk : label is "BUFGMUX_x3y6"; -- right E
attribute LOC of i_LRB4Tclk : label is "BUFGMUX_x3y9"; -- right H
attribute LOC of i_ttc_clk : label is "BUFGMUX_x0y3"; -- left B
--attribute LOC of i_SL_RX_clk : label is "BUFGMUX_x3y2"; -- right A
--attribute LOC of i_SL_RX_clkn : label is "BUFGMUX_x3y4"; -- right C
--attribute LOC of i_clk : label is "BUFGMUX_x2y10"; -- top F
--attribute LOC of i_clk180 : label is "BUFGMUX_x1y11"; -- top G
attribute LOC of i_mclk0 : label is "BUFGMUX_x1y0"; -- bottom D
attribute LOC of i_mclk90 : label is "BUFGMUX_x2y0"; -- bottom B
-- temporary
--signal slink_wep: std_logic := '0';
--signal slink_cntr: std_logic_vector(1 downto 0) := (others => '0');
begin
INIT_B <= '1' when locked = "11" else '0';
--e_wrn <= e_wrn_i;
-- LRB clocks
g_LRB0Tclkds: for i in 0 to 4 generate
	i_LRBTclkds: IBUFDS generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => LRB_TCLK_p(i), ib => LRB_TCLK_n(i), o => LRB_Tclk_in(i));
end generate;
i_LRB0Tclk: bufg port map(i => LRB_Tclk_in(0), o => LRB_Tclk(0));
--i_LRB1Tclk: bufgmux port map(i0 => SL_RX_CLK_dcm, i1 => LRB_Tclk_in(1), o => LRB_Tclk(1), s => '1');
i_LRB1Tclk: bufgmux port map(i0 => '0', i1 => LRB_Tclk_in(1), o => LRB_Tclk(1), s => '1');
i_LRB2Tclk: bufg port map(i => LRB_Tclk_in(2), o => LRB_Tclk(2));
i_LRB3Tclk: bufg port map(i => LRB_Tclk_in(3), o => LRB_Tclk(3));
i_LRB4Tclk: bufgmux port map(i0 => '0', i1 => LRB_Tclk_in(4), o => LRB_Tclk(4), s => '1');
g_LRB_link: for i in 0 to 4 generate	
	i_LRB_link: LRB_link generic map(sim => sim) PORT MAP(
		TCLKin => LRB_tclk(i),
		TD_P => LRB_TD_p(i),
		TD_n => LRB_TD_n(i),
		polarity => polarity(i),
		rCLK_P => LRB_clk_p(i),
		rCLK_n => LRB_clk_n(i),
		RD_P => LRB_rd_p(i),
		RD_n => LRB_rd_n(i),
		clk => clk,
		clk180 => clk180,
		reset => reset,
		run => run,
		n_strobe => n_strobe,
		update_led => update_led,
		vme_cycle => vme_cycle,
		addr_str => addr_str,
		vme_read => vme_read,
		rd_length => rd_length,
		LRB_ID => lrb_id(i*3+2 downto i*3),
		LRB_en => lrb_en(i*3+2 downto i*3),
		led => led(i*5+4 downto i*5),
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		lrb_test => lrb_test,
		lrb_test_str => lrb_test_str,
		lrb_test_data => lrb_test_data,
		test_ack => test_ack(i),
		LRB_ack => LRB_ack(i),
		event_data_str => event_data_str(i),
		event_data_req => event_data_req,
		re_event_info => re_event_info(i),
		re_event_data => re_event_data(i),
		rd_next_event => rd_next_event(i),
		reg_data_dav => LRB_data_dav(i),
		debug => debug(i),
		reg_data => LRB_data(i),
		event_info_rdy => event_info_rdy(i),
		event_info_val => event_info_val(i),
		event_info => event_info(i),
		event_data_rdy => event_data_rdy(i),
		event_data => event_data(i)
	);
end generate;
i_led_driver: led_driver PORT MAP(
		clk => clk,
		locked => locked(1),
		n_strobe => n_strobe,
		test_led => led_test,
		err_in => err_in,
		led_in => led_in,
		update_led => update_led,
		led => led
	);
led_in(0) <= CCLK;
led_in(1) <= ttc_ready;
led_in(2) <= inc_l1ac;
led_in(3) <= slink_send;
led_in(4) <= run;
led_in(5) <= '0';
led_in(6) <= state(3);
led_in(7) <= state(2);
led_in(8) <= state(0);
led_in(9) <= state(1);
led_in(24 downto 10) <= htr_status;
err_in(0) <= '0';
err_in(1) <= inc_bcnterr or inc_serr or inc_derr;
err_in(2) <= '0';
err_in(3) <= slink_down and en_slink;
err_in(9 downto 4) <= "000000";
err_in(24 downto 10) <= htr_error;
---- TTC clock
i_ttc_clk: bufg port map(i => T_clock40des, o => ttc_clk);
---- spare link clock
--i_SL_RX_clkds: ibufgds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => SL_RX_CLK_p, ib => SL_RX_CLK_n, o => SL_RX_CLK_in);
--i_SL_RX_CLK: bufg port map(i => SL_RX_CLK_dcm, o => SL_RX_CLK);
--i_SL_RX_CLKn: bufg port map(i => SL_RX_CLKn_dcm, o => SL_RX_CLKn);
--i_DCM_SL_RX_CLK : DCM_SP
--   generic map (CLKIN_PERIOD => 6.6,DESKEW_ADJUST => "SOURCE_SYNCHRONOUS")
--   port map (
--      CLK0 => SL_RX_CLK_dcm,     -- 0 degree DCM CLK ouptput
--      CLK180 => SL_RX_CLKn_dcm,     -- 0 degree DCM CLK ouptput
--      CLKFB => SL_RX_CLK,   -- DCM clock feedback
--      CLKIN => SL_RX_CLK_in,   -- Clock input (from IBUFG, BUFG or DCM)
--      DSSEN   => '0' ,
--      PSCLK => '0',   -- Dynamic phase adjust clock input
--      PSEN => '0',     -- Dynamic phase adjust enable input
--      PSINCDEC => '0', -- Dynamic phase adjust increment/decrement
--      RST => '0'        -- DCM asynchronous reset input
--   );
---- spare link data
--i_SL_TXCLK : OBUFDS generic map(IOSTANDARD => "LVDS_25") port map (O => SL_TX_CLK_p, OB => SL_TX_CLK_n, I => SL_TXCLK);
--	i_SL_TXCLKddr : ODDR2
--		generic map(DDR_ALIGNMENT => "C1")
--		port map (
--      Q => SL_TXCLK, -- 1-bit output data
--      C0 => clk, -- 1-bit clock input
--      C1 => clk180, -- 1-bit clock input
--      CE => '1',  -- 1-bit clock enable input
--      D0 => '1',   -- 1-bit data input (associated with C0)
--      D1 => '0',   -- 1-bit data input (associated with C1)
--      R => '0',    -- 1-bit reset input
--      S => '0'     -- 1-bit set input
--   );
--g_SL_data: for i in 0 to 4 generate
--	i_SL_TXD : OBUFDS generic map(IOSTANDARD => "LVDS_25") port map (O => SL_TXD_p(i), OB => SL_TXD_n(i), I => SL_TXD(i));
--	i_SL_TXDddr : ODDR2
--		generic map(DDR_ALIGNMENT => "C1")
--		port map (
--      Q => SL_TXD(i), -- 1-bit output data
--      C0 => clk, -- 1-bit clock input
--      C1 => clk180, -- 1-bit clock input
--      CE => '1',  -- 1-bit clock enable input
--      D0 => SL_tx_data(2*i+0),   -- 1-bit data input (associated with C0)
--      D1 => SL_rx_data(2*i+1),   -- 1-bit data input (associated with C1)
--      R => '0',    -- 1-bit reset input
--      S => '0'     -- 1-bit set input
--   );
--  i_SL_RXD: ibufds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => SL_RXD_p(i), ib => SL_RXD_n(i), o => SL_RXD(i));
--	i_SL_RXDddr : IDDR2
--		generic map(DDR_ALIGNMENT => "C1")
--		port map (
--      Q0 => SL_rx_data(2*i), -- 1-bit output captured with C0 clock
--      Q1 => SL_rx_data(2*i+1), -- 1-bit output captured with C1 clock
--      C0 => SL_RX_CLK, -- 1-bit clock input
--      C1 => SL_RX_CLKn, -- 1-bit clock input
--      CE => '1',  -- 1-bit clock enable input
--      D => SL_RXD(i),   -- 1-bit data input 
--      R => '0',    -- 1-bit reset input
--      S => '0'     -- 1-bit set input
--		);
--end generate;
--sl_tx_data <= sl_rx_data;
-- system clocks
i_rst_VMEclk : SRL16 generic map(INIT => x"ffff")
   port map (
      Q => rst_VMEp,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CLK => VMEclk_in,   -- Clock input
      D => '0'        -- SRL data input
   );
rst_vme <= rst_vmep when sim else '0';
i_VMEclkds: ibufgds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => TXCLK_p, ib => TXCLK_n, o => VMEclk_in);
i_clkfx: bufg port map(i => clkfx_dcm, o => clkfx);
i_vmeclk: bufg port map(i => vmeclk_dcm, o => vmeclk);
i_DCM_VMEclk : DCM_SP
   generic map(CLKIN_PERIOD => 10.0,CLK_FEEDBACK => "1X",
							CLKFX_DIVIDE => 2,   --  Can be any interger from 1 to 32
							CLKFX_MULTIPLY => 2, --  Can be any integer from 1 to 32
							DESKEW_ADJUST => "SOURCE_SYNCHRONOUS")  
   port map (
--      CLK2X => mclk90_dcm,     -- 0 degree DCM CLK ouptput
--			CLK2X180 => mclk270_dcm,
      CLK0 => vmeclk_dcm,     -- 0 degree DCM CLK ouptput
			CLKFX => clkfx_dcm,
      CLKFB => vmeclk,   -- DCM clock feedback
      CLKIN => VMEclk_in,   -- Clock input (from IBUFG, BUFG or DCM)
      DSSEN   => '0' ,
      PSCLK => '0',   -- Dynamic phase adjust clock input
      PSEN => '0',     -- Dynamic phase adjust enable input
      PSINCDEC => '0', -- Dynamic phase adjust increment/decrement
      RST => rst_VME,        -- DCM asynchronous reset input
			LOCKED => locked(0)
   );
i_rst_mclk : SRL16
   port map (
      Q => locked_dl(0),       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CLK => vmeclk,   -- Clock input
      D => locked(0)        -- SRL data input
   );
rst_mclk <= not locked_dl(0);
i_DCM_mclk: DCM_SP  generic map(
      CLKIN_PERIOD => 10.0, --  Specify period of input clock
--      CLKOUT_PHASE_SHIFT => "FIXED", --  Specify phase shift of "NONE", "FIXED" or "VARIABLE" 
--      PHASE_SHIFT => -47,        --  Amount of fixed phase shift from -255 to 255
			DESKEW_ADJUST => "SOURCE_SYNCHRONOUS")
	port map	
         ( CLKIN   => clkfx ,
           CLKFB   => mclk0 ,
           RST     => rst_mclk ,
           DSSEN   => '0' ,
           PSINCDEC=> '0' ,
           PSEN    => '0' ,
           PSCLK   => '0' ,
           CLK0    => mclk0_dcm ,
					 clk90  => mclk90_dcm,
           LOCKED  => locked(1));
i_mclk0 : BUFG port map (O=>mclk0, I=>mclk0_dcm);
i_mclk90 : BUFG port map (O=>mclk90, I=>mclk90_dcm);
mclk180 <= not mclk0;
mclk270 <= not mclk90;
--i_rst_clk : SRL16
--   port map (
--      Q => locked_dl(1),       -- SRL data output
--      A0 => '1',     -- Select[0] input
--      A1 => '1',     -- Select[1] input
--      A2 => '1',     -- Select[2] input
--      A3 => '1',     -- Select[3] input
--      CLK => mclk0,   -- Clock input
--      D => locked(1)        -- SRL data input
--   );
--rst_clk <= not locked_dl(1);
--i_DCM_clk: DCM_SP generic map(DESKEW_ADJUST => "SOURCE_SYNCHRONOUS", --CLK_FEEDBACK => "NONE",
----      CLKFX_DIVIDE => 4,   --  Can be any interger from 1 to 32
----      CLKFX_MULTIPLY => 3, --  Can be any integer from 1 to 32
----			CLKIN_DIVIDE_BY_2 => TRUE, -- clk 100MHz
--      CLKIN_PERIOD => 6.666 --  Specify period of input clock
--					)
--	port map	
--         ( CLKIN   => clkfx ,
----           CLKFB   => '0' ,
----           CLKFX   => clk_dcm , -- clk 150MHz
----           CLKFX180   => clk180_dcm , -- clk 150MHz
--           CLKFB   => clk_dcm ,
--           CLK0   => clk_dcm , -- clk 100MHz
----           CLK180   => clk180_dcm , -- clk 100MHz
--           RST     => rst_mclk ,
--           DSSEN   => '0' ,
--           PSINCDEC=> '0' ,
--           PSEN    => '0' ,
--           PSCLK   => '0' ,
--           LOCKED  => locked(2));
--i_clk : BUFG port map (O=>clk, I=>clk_dcm);
clk <= mclk0;
clk180 <= not mclk0;
--i_clk180 : BUFG port map (O=>clk180, I=>clk180_dcm);
i_ttc_if: ttc_if PORT MAP(
		clk => clk,
		reset => reset,
		run => run,
		n_strobe => n_strobe,
		rst_ttc => rst_ttc,
		TTC_ID => TTC_ID,
		TTC_BCN_off => TTC_BCN_offset,
		TTC_cal_win => TTC_cal_win,
		TTC_i2c_data => TTC_i2c_data,
		we_byte => we_byte,
		w_data => w_data,
		addr => addr,
		en_brcst => en_brcst,
		ttc_start => ttc_start,
		ttc_stop => ttc_stop,
		ttc_soft_reset => ttc_soft_reset,
		ttc_ready => ttc_ready,
		ttc_serr => ttc_serr,
		ttc_derr => ttc_derr,
		ttc_bcnt_err => ttc_bcnt_err,
		rate_OFW => rate_OFW,
		sync_lost => sync_lost,
		inc_oc => inc_oc,
		inc_l1ac => inc_l1ac,
		inc_bcnterr => inc_bcnterr,
		inc_serr => inc_serr,
		inc_derr => inc_derr,
		state => state,
		evn_fifo_full => evn_fifo_full,
		ttc_evcnt_reset => ttc_evcnt_reset,
		event_number_avl => event_number_avl,
		event_number => event_number,
		ttc_clk => ttc_clk,
		T_ttcready => T_ttcready,
		T_l1accept => T_l1accept,
		T_brcststr => T_brcststr,
		T_brcst => T_brcst,
		T_sinerrstr => T_sinerrstr,
		T_dberrstr => T_dberrstr,
		T_evcntres => T_evcntres,
		T_bcntres => T_bcntres,
		T_bcntstr => T_bcntstr,
		T_reset_b => T_reset_b,
		T_scl => T_scl,
		T_sda => T_sda,
		T_id => T_id
	);
i_evt_bldr: evt_bldr PORT MAP(
		reset => reset,
		reset_err => reset_err,
		clk => clk,
		version => DCC_version,
		ovfl_warning => ovfl_warning,
		evn_fifo_full => evn_fifo_full,
		ttc_evcnt_reset => ttc_evcnt_reset,
		event_number_avl => event_number_avl,
		event_number => event_number,
		lrb_en => lrb_en,
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		run => run,
		n_strobe => n_strobe,
		en_htr_ow => en_htr_ow,
		en_htr_bz => en_htr_bz,
		err_state => err_state,
		inc_l1ac => inc_l1ac,
		inc_bcnterr => inc_bcnterr,
		inc_oc => inc_oc,
		inc_serr => inc_serr,
		inc_derr => inc_derr,
		inc_rate_OFW => inc_rate_OFW,
		inc_mon_cntr => inc_mon_cntr,
		inc_slink_wc => inc_slink_wc,
		inc_slink_bc => inc_slink_bc,
		inc_crc_err => inc_crc_err,
		status_cntr => status_cntr,
		evn_mm_cntr => evn_mm_cntr,
		mmLUT_data => mm_LUT_data,
		evn_data => evn_data,
		evn_pntr => evn_pntr,
		counters => eb_counters,
		timeout_data => timeout_data,
		src_id_data => src_id_data,
		debug => debug(6),
		htr_status => htr_status,
		htr_error => htr_error,
		htr_state => htr_state,
		wp_addr => wp_addr,
		dpo_wp => dpo_wp,
		rp_addr => rp_addr,
		dpo_rp => dpo_rp,
		summary => summary,
		lrb_evn => lrb_evn,
		evn_ra => evn_ra,
		smry_ra => smry_ra,
		htr_rd_cnt => htr_rd_cnt,
		htr_rd_cnt_str => htr_rd_cnt_str,
		htr_buf_addr => htr_buf_addr,
		htr_buf_length => htr_buf_length,
		htr_buf_req => htr_buf_req,
		htr_buf_data => htr_buf_data,
		htr_buf_val => htr_buf_val,
		TTS => state,
		slink_we => slink_we,
		slink_data => slink_data
	);
process(clk)
begin
  if(clk'event and clk = '1')then
		event_buf_afull <= slink_full or mon_fifo_afull or (mon_buf_afull and conf(14)) or conf(3);
  end if;
end process;
i_edc: edc PORT MAP(
		clk => clk,
		n_strobe => n_strobe,
		reset => reset,
		test_ctrl => test_ctrl(3 downto 0),
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		lrb_test => lrb_test,
		htr_buf_addr => htr_buf_addr,
		htr_buf_length => htr_buf_length,
		htr_buf_req => htr_buf_req,
		event_data_rdy => event_data_rdy,
		lrb0_event_data => event_data(0),
		lrb1_event_data => event_data(1),
		lrb2_event_data => event_data(2),
		lrb3_event_data => event_data(3),
		lrb4_event_data => event_data(4),
		event_info_rdy => event_info_rdy,
		event_info_val => event_info_val,
		lrb0_event_info => event_info(0),
		lrb1_event_info => event_info(1),
		lrb2_event_info => event_info(2),
		lrb3_event_info => event_info(3),
		lrb4_event_info => event_info(4),
		event_buf_afull => event_buf_afull,
		lrb_ack => test_ack,
		htr_rd_cnt => htr_rd_cnt,
		htr_rd_cnt_str => htr_rd_cnt_str,
		rp_addr => rp_addr,
		rp => dpo_rp,
		en_HTR_bz => en_HTR_bz,
		htr_state_LUT => htr_state_LUT,
		HTR_ow => HTR_ow,
		HTR_bz => HTR_bz,
		HTR_state => htr_state,
		htr_buf_ovf => htr_buf_ovf,
		wp_addr => wp_addr,
		dpo_wp => dpo_wp,
		evn_ra => evn_ra,
		smry_ra => smry_ra,
		summary => summary,
		lrb_evn => lrb_evn,
		re_event_data => re_event_data,
		rd_next_event => rd_next_event,
		re_event_info => re_event_info,
		event_data_req_str => event_data_str,
		event_data_req => event_data_req,
		event_data_val => htr_buf_val,
		event_data => htr_buf_data,
		lrb_test_str => lrb_test_str,
		lrb_test_data => lrb_test_data,
		debug_addr => edc_dbg_addr(16 downto 2),
		counter_addr => edc_cntr_addr(16 downto 2),
		counters => edc_counters,
		debug => debug(5)
	);
I_slink: slink PORT MAP(
		clk => clk,
		reset => slink_rst,
		n_strobe => n_strobe,
		slink_pntr => slink_pntr,
		slink_buf => slink_buf,
		we_byte => we_byte,
		addr => addr,
		w_data => w_data,
		en_slink => en_slink,
		slink64 => slink64,
		slink_ctrl => slink_ctrl,
		slink_din => slink_data,
		slink_we => slink_we,
		slink_send => slink_send,
		slink_full => slink_full,
		slink_down => slink_down,
		inc_slink_wc => inc_slink_wc,
		inc_slink_bc => inc_slink_bc,
		inc_crc_err => inc_crc_err,
		slink_test => slink_test,
		LDOWNn => LDOWNn,
		LFFn => LFFn,
		LRL => LRL,
		LSF => LSF,
		UCLK => UCLK,
		UTESTn => UTESTn,
		UWENn => UWENn,
		URESETn => URESETn,
		UCTRLn => UCTRLn,
		UDW => UDW,
		UD => UD,
		USF => USF
	);
slink64 <= '1';
slink_ctrl <= conf(7) when run = '0' else slink_data(34);
--process(clk)
--begin
--  if(clk'event and clk = '1')then
--		if(strobe = '1' and update_led = '1')then
--			led_in <= led_in(23 downto 0) & not led_in(24);
--			err_in <= err_in(22 downto 0) & not led_in(24 downto 23);
--		end if;
----		slink_data <= event_info(0) or event_info(1) or event_info(2) or event_info(3) or event_info(4);
--		slink_we <= slink_wep;
--		if(reset = '1')then
--			slink_cntr <= "00";
--			slink_wep <= '0';
--		elsif(re_event_info /= "00000")then
--			slink_cntr <= slink_cntr + 1;
--			slink_wep <= '1';
--		else	
--			slink_wep <= '0';
--		end if;
--  end if;
--end process;
i_sdram: sdram_b generic map( sim => sim, clk_speed => 1) PORT MAP(
		reset => reset,
		clk => clk,
		mclk0 => mclk0,
		mclk90 => mclk90,
		mclk180 => mclk180,
		mclk270 => mclk270,
		n_strobe => n_strobe,
		locked => locked(1),
		mem_status => mem_status,
		rst_rfifo_data => rst_mem_data,
		rfifo_data => mem_data,
		rfifo_dav => rfifo_dav,
		ddr_gnt => ddr_gnt,
		ddr_w_we => ddr_w_we,
		ddr_read => ddr_read,
		ddr_rqst => ddr_rqst,
		ddr_length => ddr_length,
		ddr_addr => ddr_addr,
		ddr_w_data => ddr_w_data,
--		tc => tc,
		mclkio => mclkio,
		mdq => mdq,
		ma => ma,
		mba => mba,
		dm => dm,
		dqs => dqs,
		we_n => we_n,
		ras_n => ras_n,
		cas_n => cas_n,
		cs_n => cs_n,
		mclke => mclke,
		mclk => mclk,
		mclk_n => mclk_n
	);
i_ddr_rw_ctrl: ddr_rw_ctrl PORT MAP(
		reset => reset,
		clk => clk,
		mclk0 => mclk0,
		mon_data => mon_data,
		mon_re => mon_re,
		mon_avl => mon_avl,
		mon_we => mon_we,
		ddr_gnt => ddr_gnt,
		ddr_we => ddr_w_we,
		ddr_read => ddr_read,
		ddr_rqst => ddr_rqst,
		ddr_length => ddr_length,
		ddr_addr => ddr_addr,
		ddr_w_data => ddr_w_data,
		w_data => w_data,
		debug => ddr_w_addr,
		ddr_pa => ddr_pa_off,
		addr => addr,
		run => run,
		n_strobe => n_strobe,
		mem_test => mem_test,
		vme_cycle => vme_cycle,
		addr_str => addr_str,
		vme_read => vme_read,
		rd_length => rd_length,
		we_byte => we_byte
	);
i_monitor: monitor PORT MAP(
		clk => clk,
		reset => reset,
		n_strobe => n_strobe,
		run => run,
		we_byte => we_byte,
		addr => addr,
		w_data => w_data,
		mon_evt_wc => mon_evt_wc,
		mon_ctrl => mon_ctrl,
		mon_buf_empty => mon_buf_empty,
		mon_buf_full => mon_buf_full,
		mon_buf_afull => mon_buf_afull,
		mon_fifo_afull => mon_fifo_afull,
		inc_ddr_pa => inc_ddr_pa,
		mon_re => mon_re,
		mon_avl => mon_avl,
		mon_we => mon_we,
		mon_data => mon_data,
		mon_wp => mon_wp,
		ddr_pa => ddr_pa_off(6 downto 0),
		inc_mon_cntr => inc_mon_cntr,
		inc_crc_err => inc_crc_err,
		catch_offset => catch_offset,
		slink_we => slink_we,
		slink_data => slink_data
	);
i_vme_link: vme_link generic map(sim => sim) PORT MAP(
		clk => clk,
		clk180 => clk180,
		n_strobe => n_strobe,
		clk_lock => locked(1),
		vmeclk => not vmeclk,
		et_str => et_str,
		et_read => et_read,
		et_rd_length => et_rd_length,
		et_addr => et_addr,
		et_wdata => et_wdata,
		et_sel => et_sel,
		et_abort => et_abort,
		TXD_p => TXD_p,
		TXD_n => TXD_n,
		RXCLK_P => RXCLK_p,
		RXCLK_n => RXCLK_n,
		RXD_P => RXD_p,
		RXD_n => RXD_n,
		vme_cycle => vme_cycle,
		mem_test => mem_test,
		vme_read => vme_read,
		LRB_ack => LRB_ack,
		addr_str => addr_str,
		inc_addr => inc_addr,
		r_data_val => r_data_val,
		addr => addr,
		rd_length => rd_length,
		r_data => r_data,
		we_byte => we_byte,
		w_data => w_data
	);
e_resetn <= locked(0);
--e_data <= e_data_out when e_wrn_i = '0' else (others => 'Z');
i_ethernetnew: ethernetnew PORT MAP(
		clk => clk,
		n_strobe => n_strobe,
		reset => reset,
		addr_str => addr_str,
		mod_sn => SN,
		addr => addr,
		r_data => r_data,
		e_csn => e_csn,
		e_wrn => e_wrn,
		e_rdn => e_rdn,
		e_data => e_data,
--		e_data_out => e_data_out,
		e_addr => e_addr,
		en_write => conf(6),
		ethernet_sel => et_sel,
		ethernet_abort => et_abort,
		r_data_val => r_data_val,
		ethernet_addr => et_addr,
		ethernet_rd_length => et_rd_length,
		ethernet_wdata => et_wdata,
		ethernet_read => et_read,
		ethernet_str => et_str,
		debug => ethernet_data
	);
--e_data <= e_data_o when t_e_data = '0' else (others => 'Z');
--i_ethernet: ethernet PORT MAP(
--		clk => clk,
--		n_strobe => n_strobe,
--		reset => reset,
--		update_led => update_led,
--		addr_str => addr_str,
--		vme_cycle => vme_cycle,
--		vme_read => vme_read,
--		we_byte => we_byte,
--		w_data => w_data,
--		mod_sn => x"00",
--		e_csn => e_csn,
--		e_wrn => e_wrn,
--		e_rdn => e_rdn,
--		e_addr => e_addr,
--		e_resetn => e_resetn,
--		ethernet_data => ethernet_data,
--		ethernet_dav => ethernet_dav,
--		e_data_i => e_data,
--		e_data_o => e_data_o,
--		t_e_data => t_e_data,
--		e_intn => e_intn,
--		addr => addr,
--		ethernet_addr => ethernet_addr(17 downto 2),
--		bus_gnt => '0',
--		bus_rqst => open
--	);
run <= conf(0);
en_slink <= conf(1);
slink_test <= conf(2);
en_brcst <= conf(5);
lrb_test <= test_ctrl(4);
led_test <= test_ctrl(5);
status(0) <= slink_down;
status(1) <= slink_full;
status(2) <= mon_buf_full;
status(3) <= mon_buf_empty;
status(4) <= '0';
status(5) <= not ttc_ready;
status(6) <= ttc_bcnt_err;
status(7) <= ttc_serr;
status(8) <= ttc_derr;
status(9) <= state(1);
status(10) <= not LFFn;
status(11) <= '0';
status(12) <= '0';
status(13) <= state(0);
status(14) <= state(2);
status(15) <= not state(3);
status(30 downto 16) <= htr_buf_ovf;
process(clk)
begin
  if(clk'event and clk = '1')then
    strobe <= n_strobe;
		if(strobe = '1')then
			got_SN <= got_SN or addr_str;
			if(got_SN = '0' and addr_str = '0')then
				SN <= w_data(30 downto 24) & w_data(20);
			end if;
		  if(ttc_soft_reset = '1')then
				reset <= '1';
				reset_err <= '1';
			elsif(addr(14 downto 0) = CSR_addr(16 downto 2) and we_byte(3) = '1')then
				reset <= w_data(0);
				reset_err <= w_data(3);
			else
				reset <= '0';
				reset_err <= '0';
			end if;
			if(addr(14 downto 0) = CSR_addr(16 downto 2) and we_byte(3) = '1')then
				slink_rst <= w_data(1);
				rst_ttc <= w_data(2);
			else
				slink_rst <= '0';
				rst_ttc <= '0';
			end if;
			if(addr(14 downto 0) = CFG_addr(16 downto 2))then
				if(we_byte(3) = '1')then
					conf(7) <= conf(7) or w_data(7);
					conf(6) <= conf(6) or (w_data(6) and not et_sel);
					conf(5 downto 0) <= conf(5 downto 0) or w_data(5 downto 0);
				end if;
				if(we_byte(2) = '1')then
					conf(15 downto 8) <= conf(15 downto 8) or w_data(15 downto 8);
				end if;
				if(we_byte(1) = '1')then
					if(w_data(23) = '1')then
						conf(7) <= '0';
					end if;
					if(w_data(22) = '1' and et_sel = '0')then
						conf(6) <= '0';
					end if;
					for i in 0 to 5 loop
						if(w_data(16+i) = '1')then
							conf(i) <= '0';
						end if;
					end loop;
				end if;
				if(we_byte(0) = '1')then
					for i in 8 to 15 loop
						if(w_data(16+i) = '1')then
							conf(i) <= '0';
						end if;
					end loop;
				end if;
			end if;
			if(run = '1')then
				conf(12) <= '0';
			end if;
			if(mem_test = '1' or (addr(14 downto 13) = mem_buf_addr(16 downto 15) and vme_cycle = '1' and vme_read = '1'))then
				rst_mem_data <= '0';
			else
				rst_mem_data <= '1';
			end if;
			if(run = '1')then
				test_ctrl <= (others => '0');
			elsif(addr(14 downto 0) = test_ctrl_addr(16 downto 2))then
				if(we_byte(3) = '1')then
					test_ctrl(7 downto 0) <= w_data(7 downto 0);
				end if;
--				if(we_byte(2) = '1')then
--					test_ctrl(15 downto 8) <= w_data(15 downto 8);
--				end if;
			end if;
			if(rst_ddr_pa = '1')then
				ddr_pa <= (others => '0');
			elsif(addr(14 downto 0) = PAGE_addr(16 downto 2))then
				if(run = '1')then 
					if(we_byte /= x"0" and mon_buf_empty = '0')then
						ddr_pa(6 downto 0) <= ddr_pa(6 downto 0) + 1;
					end if;
				else
					if(we_byte(3) = '1')then
						ddr_pa(7 downto 0) <= w_data(7 downto 0);
					end if;
					if(we_byte(2) = '1')then
						ddr_pa(9 downto 8) <= w_data(9 downto 8);
					end if;
				end if;
			end if;
			if(rst_ddr_pa = '1')then
				inc_ddr_pa <= '0';
			elsif(addr(14 downto 0) = PAGE_addr(16 downto 2))then
				if(run = '1' and we_byte /= x"0" and mon_buf_empty = '0')then
					inc_ddr_pa <= '1';
				else
					inc_ddr_pa <= '0';
				end if;
			else
				inc_ddr_pa <= '0';
			end if;
			if(addr(14 downto 0) = HTR_EN_addr(16 downto 2))then
				if(we_byte(3) = '1')then
					lrb_en(4 downto 0) <= w_data(7 downto 3);
				end if;
				if(we_byte(2) = '1')then
					lrb_en(12 downto 5) <= w_data(15 downto 8);
				end if;
				if(we_byte(1) = '1')then
					lrb_en(14 downto 13) <= w_data(17 downto 16);
				end if;
			end if;
			if(vme_cycle = '0' and mem_test = '0')then
				r_data_val <= '0';
			elsif((addr(14) = '1' and addr(12 downto 10) /= "101") or addr(13) = '1')then
				r_data_val <= rfifo_dav or or_reduce(LRB_data_dav);
			else
				r_data_val <= wc4_dl;
			end if;
			if(vme_cycle = '0' or (addr(14) = '1' and addr(12 downto 10) /= "101") or addr(13) = '1' or vme_read = '0')then
				wc <= (others => '0');
			elsif(addr_str = '1')then
				wc <= '1' & not rd_length;
			elsif(wc(4) = '1')then
				wc <= wc + 1;
			end if;
			wc4_dl <= wc(4);
		end if;
  end if;
end process;
inc_addr <= wc(4);
process(clk)
begin
  if(clk'event and clk = '1')then
		if(strobe = '1')then
			r_data <= mem_data or debug(0) or debug(1) or debug(2) or debug(3) or debug(4) or debug(5) or debug(6) or debug(7) or 
								LRB_data(0) or LRB_data(1) or LRB_data(2) or LRB_data(3) or LRB_data(4) or reg_data or ethernet_data or
								edc_counters or htr_state_LUT or eb_counters or status_cntr or evn_mm_cntr or mm_LUT_data or slink_buf or evn_data;
			if(addr(14 downto 4) /= "00000000000")then
				reg_data <= (others =>'0');
			else
				case addr(3 downto 0) is
					when x"0" => reg_data <= status;
					when x"1" => reg_data <= conf;
					when x"2" => reg_data <= mon_ctrl;
					when x"3" => reg_data <= x"000" & "00" & lrb_en & "000";
					when x"4" => reg_data <= TTC_id;
					when x"5" => reg_data <= TTC_i2c_data;
					when x"6" => reg_data <= timeout_data;
					when x"7" => reg_data <= src_id_data;
					when x"8" => reg_data <= TTC_BCN_offset;
					when x"9" => reg_data <= TTC_cal_win;
					when x"a" => reg_data <= SN & x"00" & mem_status;
					when x"b" => reg_data <= test_ctrl;
					when x"c" => reg_data <= x"00000" & "00" & ddr_pa;
					when x"d" => reg_data <= mon_evt_wc;
					when x"e" => reg_data <= evn_pntr;
					when others => reg_data <= slink_pntr;
				end case;
			end if;
		end if;
  end if;
end process;
conf(31 downto 16) <= DCC_version;
process(clk)
begin
  if(clk'event and clk = '1')then
		if(strobe = '1')then
			if(mem_test = '0')then
			 lfsr <= (others => '0');
			elsif(rfifo_dav = '1')then
			 lfsr <= lfsr(30 downto 0) & not(lfsr(31) xor lfsr(21) xor lfsr(1) xor lfsr(0));
			end if;
			if(reset_err = '1')then
				lfsr_err <= '0';
			elsif(rfifo_dav = '1' and lfsr /= mem_data)then
				lfsr_err <= '1';
			end if;
			if(reset_err = '1')then
				lfsr_reg <= (others => '0');
				mem_reg <= (others => '0');
			elsif(lfsr_err = '0' and mem_test = '1')then
				lfsr_reg <= lfsr;
				mem_reg <= mem_data;
			end if;
			if(mem_test = '0')then
			 lfsr2 <= (others => '0');
			elsif(we_byte(3) = '1')then
			 lfsr2 <= lfsr2(30 downto 0) & not(lfsr2(31) xor lfsr2(21) xor lfsr2(1) xor lfsr2(0));
			end if;
			if(reset_err = '1')then
				lfsr2_err <= '0';
			elsif(we_byte(3) = '1' and lfsr2 /= w_data)then
				lfsr2_err <= '1';
			end if;
			if(reset_err = '1')then
				lfsr2_reg <= (others => '0');
				w_data_reg <= (others => '0');
			elsif(lfsr2_err = '0' and we_byte(3) = '1')then
				lfsr2_reg <= lfsr2;
				w_data_reg <= w_data;
			end if;
			if(addr(14 downto 6) = mem_dbg_addr(16 downto 8) and we_byte(3) = '1')then
				sl_txd_p <= w_data(11 downto 7);
				sl_tx_clk_p <= w_data(6);
				sl_txd_n <= w_data(5 downto 1);
				sl_tx_clk_n <= w_data(0);
			end if;
			if(addr(14 downto 6) = mem_dbg_addr(16 downto 8))then
				case addr(2 downto 0) is
					when "000" => debug(7) <= mem_reg;
					when "001" => debug(7) <= lfsr_reg;
					when "010" => debug(7) <= w_data_reg;
					when "011" => debug(7) <= lfsr2_reg;
					when "100" => debug(7) <= last_evn;
					when "101" => debug(7) <= last_w_addr;
					when "110" => debug(7) <= x"00000" & sl_rxd_n(4 downto 3) & sl_rxd_p(2) & sl_rxd_n(1) & sl_rxd_p(0) & sl_rx_clk_n & sl_rxd_p(4 downto 3) & sl_rxd_n(2) & sl_rxd_p(1) & sl_rxd_n(0) & sl_rx_clk_p;
					when others => debug(7) <= ddr_w_addr;
				end case;
			else
				debug(7) <= (others => '0');
			end if;
		end if;
		if(ddr_gnt = '1' and ddr_read = '0')then
			last_w_addr <= "000000000" & ddr_addr;
		end if;
		wr_evn <= mon_we and mon_data(33);
		if(wr_evn = '1')then
			last_evn <= mon_data(31 downto 0);
		end if;
--		if(reset = '1')then
--			odd_ctrl <= '0';
--			odd_data <= '0';
--			ctrl_length_err <= (others => '0');
--			data_length_err <= (others => '0');
--		elsif(slink_we = '1')then
--			if(slink_data(34) = '1')then
--				odd_ctrl <= not odd_ctrl;
--				odd_data <= '0';
--				if(odd_data = '1')then
--					data_length_err <= data_length_err + 1;
--				end if;
--			else
--				odd_data <= not odd_data;
--				odd_ctrl <= '0';
--				if(odd_ctrl = '1')then
--					ctrl_length_err <= ctrl_length_err + 1;
--				end if;
--			end if;
--		end if;
  end if;
end process;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(strobe = '1')then
			if(resync_done = '1' or run = '0')then
				ttc_resync <= '0';
      elsif(ttc_soft_reset = '1')then
				ttc_resync <= '1';
			end if;
			if(reset = '1' or (we_byte(3) = '1' and addr(14 downto 0) = MON_ctrl_addr(16 downto 2)))then
				rst_ddr_pa <= '1';
			else
				rst_ddr_pa <= '0';
			end if;
			if(ttc_resync = '0' or conf(13) = '1')then
				oc_cntr <= "0000";
			elsif(inc_oc = '1')then
				oc_cntr <= oc_cntr + 1;
			end if;
			if(oc_cntr = "1010" or (conf(13) = '1' and ttc_soft_resetp = '1'))then
				resync_done <= '1';
			else
				resync_done <= '0';
			end if;
			if(slink_we = '1' or ttc_resync = '0')then
				dcc_quiet <= '0';	
			elsif(inc_oc = '1')then
				dcc_quiet <= '1';
			end if;
			if((conf(13) = '0' and oc_cntr(3) = '0' and ttc_resync = '1') or (conf(13) = '1' and dcc_quiet = '1' and inc_oc = '1'))then
				ttc_soft_resetp <= '1';
			else
				ttc_soft_resetp <= '0';
			end if;
			if(run = '0')then
				ddr_pa_off(9 downto 7) <= ddr_pa(9 downto 7);
			else
				ddr_pa_off(9 downto 7) <= "000";
			end if;
			if(catch_offset = '0')then
				ddr_pa_off(6 downto 0) <= ddr_pa(6 downto 0);
			else
				ddr_pa_off(6 downto 0) <= ddr_pa(6 downto 0) + mon_wp;
			end if;
		end if;
		if(reset = '1')then
			status(31) <= '0';
		elsif(oc_cntr(3) = '1' and event_info_rdy /= "00000")then
			status(31) <= '1';
		end if; 
		rate_OFW_q <= rate_OFW;
		inc_rate_OFW <= not rate_OFW_q and rate_OFW;
		rate_OFWp <= rate_OFW and conf(15);
    if(reset = '1')then
			state <= "0100";
		elsif(strobe = '1')then
			if(conf(12) = '1')then
				state <= conf(11 downto 8);
			elsif(run = '0')then
--				state <= "1111";
				state <= "0100"; -- changed upon request starting version 0x3023
			elsif(ttc_resync = '1' or status(31) = '1')then
				state <= "0100";
			else
        case state is
					when "1000" =>
						if(err_state = "11")then
							state <= "1111";
						elsif(err_state = "10")then
							state <= "1100";
						elsif(sync_lost = '1' or err_state = "01")then
							state <= "0010";
--						elsif(ovfl_warning = '1' or (HTR_ow = '1' and en_htr_ow = '1') or evn_fifo_full = '1' or (HTR_bz = '1' and en_htr_bz = '1') or rate_OFWp = '1')then
						elsif(ovfl_warning = '1' or (HTR_ow = '1' and en_htr_ow = '1') or evn_fifo_full = '1' or HTR_bz = '1' or rate_OFWp = '1')then
							state <= "0001";
						end if;  
					when "0001" =>
						if(err_state = "11")then
							state <= "1111";
						elsif(err_state = "10")then
							state <= "1100";
						elsif(sync_lost = '1' or err_state = "01")then
							state <= "0010";
--						elsif(evn_fifo_full = '1' or (HTR_bz = '1' and en_htr_bz = '1') or rate_OFWp = '1')then
						elsif(evn_fifo_full = '1' or HTR_bz = '1' or rate_OFWp = '1')then
							state <= "0100";
						elsif(ovfl_warning = '0' and (HTR_ow = '0' or en_htr_ow = '0') and rate_OFWp = '0')then
							state <= "1000";
						end if;  
					when "0100" =>
						if(err_state = "11")then
							state <= "1111";
						elsif(err_state = "10")then
							state <= "1100";
						elsif(sync_lost = '1' or err_state = "01")then
							state <= "0010";
--						elsif(evn_fifo_full = '0' and (HTR_bz = '0' or en_htr_bz = '0') and rate_OFWp = '0')then
						elsif(evn_fifo_full = '0' and HTR_bz = '0' and rate_OFWp = '0')then
							state <= "0001";
						end if;  
					when others => null;
				end case;
			end if;
		end if;
  end if;
end process;
OVERFLOW <= state(0);
OUT_OF_SYNC <= state(1);
BUSY <= state(2);
READY <= state(3);
end Behavioral;

