----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:55:03 03/16/2007 
-- Design Name: 
-- Module Name:    srl_fifo - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity srl_fifo32 is
    generic (N: integer := 32);
    port (
        rst: 	in STD_LOGIC;
        din: 	in STD_LOGIC_VECTOR (N-1 downto 0);
        w_strobe: 	in STD_LOGIC;
        we: 	in STD_LOGIC;
        clk: 	in STD_LOGIC;
        r_strobe: 	in STD_LOGIC;
        re: 	in STD_LOGIC;
        dav: 	out STD_LOGIC;
        dout: 	out STD_LOGIC_VECTOR (N-1 downto 0);
        rp: 	out STD_LOGIC_VECTOR (4 downto 0)
    );
end srl_fifo32;

architecture Behavioral of srl_fifo32 is
signal qa:			std_logic_vector(N-1 downto 0) := (others => '0');
signal q15:			std_logic_vector(N-1 downto 0) := (others => '0');
signal qb:			std_logic_vector(N-1 downto 0) := (others => '0');
signal dout_i:	std_logic_vector(N-1 downto 0) := (others => '0');
signal a:			std_logic_vector(4 downto 0) := (others => '1');
signal wep:		std_logic := '1';
signal empty:		std_logic := '1';
signal dav_i:		std_logic := '0';
begin
rp <= a;
dav <= dav_i;
dout <= dout_i;
g1: for i in qa'range generate
  i_qa: srlc16e port map(
                             d => din(i),
                             ce => wep,
                             clk => clk,
                             a0 => a(0),
                             a1 => a(1),
                             a2 => a(2),
                             a3 => a(3),
														 q15 => q15(i),
                             q  => qa(i));
  i_qb: srlc16e port map(
                             d => q15(i),
                             ce => wep,
                             clk => clk,
                             a0 => a(0),
                             a1 => a(1),
                             a2 => a(2),
                             a3 => a(3),
                             q  => qb(i));
end generate;
empty <= '1' when a = "11111" else '0'; 
wep <= we and w_strobe;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(rst = '1')then
			a <= (others => '1');
		elsif(wep /= ((re or not dav_i) and r_strobe and not empty))then
			if(wep = '1')then
				a <= a + 1;
			else
				a <= a - 1;
			end if;
		end if;
    if((re = '1' or dav_i = '0') and r_strobe = '1')then
			if(a(4) = '0')then
				dout_i <= qa;
			else
				dout_i <= qb;
			end if;
    end if;
		if(rst = '1')then
			dav_i <= '0';
		elsif(r_strobe = '1')then
			if(a /= "11111")then
				dav_i <= '1';
			elsif(re = '1')then
				dav_i <= '0';
			end if;
		end if;
  end if;
end process; 
end Behavioral;

